#ifndef _Dbasedraw_H_
#define _Dbasedraw_H_

enum
{

	BASEDRAW_GROUP_VIEW = 100,
	BASEDRAW_GROUP_HUD,
	BASEDRAW_GROUP_ACTIVEOBJECT,
	BASEDRAW_GROUP_INACTIVEOBJECT,
	BASEDRAW_GROUP_DISPLAY,
	BASEDRAW_GROUP_BACKGROUND,
	BASEDRAW_GROUP_HUD_CONTROLS,
	BASEDRAW_GROUP_HUD_INFORMATION,
	BASEDRAW_GROUP_FILTER,
	BASEDRAW_GROUP_INSTANTRENDER,

	BASEDRAW_DATA_TEXTURES								= 1000, // BOOL
	BASEDRAW_DATA_BACKCULL								= 1001, // BOOL
	BASEDRAW_DATA_SHOWSAFEFRAME						= 1002, // BOOL
	BASEDRAW_DATA_SDISPLAYACTIVE					= 1003, // LONG
	BASEDRAW_DATA_SDISPLAYINACTIVE				= 1004, // LONG
	BASEDRAW_DATA_USEPROPERTIESACTIVE			= 1005, // BOOL
	BASEDRAW_DATA_USEPROPERTIESINACTIVE		= 1006, // BOOL
	BASEDRAW_DATA_SHOWNORMALS							= 1007, // BOOL
	BASEDRAW_DATA_SHOWPATH								= 1008, // BOOL
	BASEDRAW_DATA_SHOWPICTURE							= 1009, // BOOL
	BASEDRAW_DATA_XRAY										= 1010, // BOOL
	BASEDRAW_DATA_PICTURE									= 1011, // FILENAME
	BASEDRAW_DATA_OFFSETX									= 1012, // REAL
	BASEDRAW_DATA_OFFSETY									= 1013, // REAL
	BASEDRAW_DATA_SIZEX										= 1014, // REAL
	BASEDRAW_DATA_SIZEY										= 1015, // REAL
	BASEDRAW_DATA_LIGHTVECTOR							= 1016, // VECTOR
	BASEDRAW_DATA_STACKEDMATERIALS				= 1017, // BOOL
	BASEDRAW_DATA_PROJECTION							= 1018,	// LONG
	BASEDRAW_DATA_RENDERSAFE							= 1019,	// BOOL
	BASEDRAW_DATA_TITLESAFE								= 1020,	// BOOL
	BASEDRAW_DATA_ACTIONSAFE							= 1021,	// BOOL
	BASEDRAW_DATA_SELECTED_NORMALS				= 1022,	// BOOL
	BASEDRAW_DATA_TITLESAFE_SIZE						= 1023,	// REAL
	BASEDRAW_DATA_ACTIONSAFE_SIZE					= 1024,	// REAL
	BASEDRAW_DATA_TRANSAXES								= 1025,	// BOOL
	BASEDRAW_DATA_TRANSAXES_OPACITY				= 1026,	// REAL
	BASEDRAW_DATA_OBJECTAXIS_OBJECTSCALE	= 1027,	// BOOL
	BASEDRAW_DATA_OBJECTAXIS_SCALE				= 1028,	// REAL
	BASEDRAW_DATA_KEEP_ASEPECT						= 1029, // BOOL
	BASEDRAW_DATA_TINT_POLYGON_SELECTION	= 1030, // BOOL
	BASEDRAW_DATA_BAND_POSITION						= 1031,	// REAL
	BASEDRAW_DATA_BAND_SIZE								= 1032,	// REAL
	BASEDRAW_DATA_POINT_HANDLE_SIZE				= 1033,	// LONG
	BASEDRAW_DATA_SDSEDIT									= 1035,	// BOOL
	BASEDRAW_DATA_DEFORMEDEDIT						= 1036,	// BOOL
	BASEDRAW_DATA_PICTURE_TRANSPARENCY		= 1037, // REAL
	BASEDRAW_DATA_PICTURE_USEALPHA				= 1038, // LONG
		BASEDRAW_ALPHA_NONE			= 10,
		BASEDRAW_ALPHA_INVERTED	= 11,
		BASEDRAW_ALPHA_NORMAL		= 12,
	BASEDRAW_DATA_CAMERA									= 1039, // LINK
	BASEDRAW_TITLE												= 1040, // STRING
	BASEDRAW_DATA_DISPLAYINACTIVE_ENABLED	= 1041, // BOOL
	BASEDRAW_DATA_WDISPLAYACTIVE					= 1042, // LONG
	BASEDRAW_DATA_WDISPLAYINACTIVE				= 1043, // LONG

	BASEDRAW_DATA_EDGE_POINTS					= 1044, // BOOL
	BASEDRAW_DATA_SHADE_HANDLES					= 1045, // BOOL
	BASEDRAW_DATA_NORMALS_SCALE					= 1046, // BOOL
	BASEDRAW_DATA_ROTBAND_SCALE					= 1047, // REAL
	BASEDRAW_DATA_EDIT_AXIS_SCALE				= 1048, // REAL
	BASEDRAW_DATA_EDIT_AXIS_TEXT				= 1049, // BOOL
	BASEDRAW_DATA_ACTIVE_STEMS					= 1050, // BOOL
	BASEDRAW_DATA_PICTURE_ROTATION				= 1051, // REAL

	BASEDRAW_DATA_SNAP_PLANE_SPACING			= 1052, // REAL - Grid Spacing
	BASEDRAW_DATA_SNAP_PLANE_SUB					= 1053, // LONG - Subdivision
	BASEDRAW_DATA_SNAP_PLANE_ROUGHSUB			= 1054, // LONG - Subdivision

	BASEDRAW_DATA_SNAP_PLANE_DYNAMICGRID	= 1056, // LONG
		SNAP_PLANE_DYNAMICGRID_0	= 0, // LONG
		SNAP_PLANE_DYNAMICGRID_1	= 1, // LONG
		SNAP_PLANE_DYNAMICGRID_2	= 2, // LONG
		SNAP_PLANE_DYNAMICGRID_3	= 3, // LONG
		SNAP_PLANE_DYNAMICGRID_4	= 4, // LONG
	BASEDRAW_DATA_PLANE_SEP								= 1057,
	BASEDRAW_DATA_ROTATION_BANDS						= 1058,

	BASEDRAW_DATA_BOUNDINGBOXSELECTION					= 1059,
	BASEDRAW_DATA_WIREFRAMESELECTION						= 1060,
	BASEDRAW_DATA_BOUNDINGBOXSELECTION_CHILDREN	= 1061,
	BASEDRAW_DATA_WIREFRAMESELECTION_CHILDREN		= 1062,
	BASEDRAW_DATA_TINT_POLYGON_NORMALS				= 1063,
	BASEDRAW_DATA_ROTATION_CIRCLE					= 1064,

//

	BASEDRAW_HUD_BEGIN										= 2000,

	BASEDRAW_HUD_BACKCOLOR								= 2001,	// VECTOR
	BASEDRAW_HUD_TEXTCOLOR								= 2002,	// VECTOR
	BASEDRAW_HUD_BACKOPACITY							= 2003,	// REAL
	BASEDRAW_HUD_TEXTOPACITY							= 2004,	// REAL
	BASEDRAW_HUD_ALWAYSACTIVE							= 2005, // BOOL
	BASEDRAW_HUD_SELECTCOLOR							= 2007,	// VECTOR

	BASEDRAW_HUD_ELEMENTS_BEGIN,

	BASEDRAW_HUD_FPS,
	BASEDRAW_HUD_CAMERADISTANCE,
	BASEDRAW_HUD_FRAME,
	BASEDRAW_HUD_FRAMETIME,
	BASEDRAW_HUD_CAMERA_NAME,
	BASEDRAW_HUD_PROJECTION_NAME,

	BASEDRAW_HUD_OBJECTS,
	BASEDRAW_HUD_ROOT_OBJECT,
	BASEDRAW_HUD_PARENT_OBJECT,
	BASEDRAW_HUD_ACTIVE_OBJECT,

	BASEDRAW_HUD_SELECTED,
	BASEDRAW_HUD_TOTAL_OBJECTS,
	BASEDRAW_HUD_TOTAL_POINTS,
	BASEDRAW_HUD_TOTAL_EDGES,
	BASEDRAW_HUD_TOTAL_POLYGONS,
	BASEDRAW_HUD_TOTAL_NGONS,
	BASEDRAW_HUD_SELECTED_OBJECTS,
	BASEDRAW_HUD_SELECTED_POINTS,
	BASEDRAW_HUD_SELECTED_EDGES,
	BASEDRAW_HUD_SELECTED_POLYGONS,
	BASEDRAW_HUD_SELECTED_NGONS,

	BASEDRAW_HUD_ELEMENTS_END,

	BASEDRAW_HUD_END,

	BASEDRAW_DISPLAYFILTER_BEGIN				= 3000,

	BASEDRAW_DISPLAYFILTER_NULL,
	BASEDRAW_DISPLAYFILTER_POLYGON,
	BASEDRAW_DISPLAYFILTER_SPLINE,
	BASEDRAW_DISPLAYFILTER_GENERATOR,
	BASEDRAW_DISPLAYFILTER_HYPERNURBS,
	BASEDRAW_DISPLAYFILTER_BONE,
	BASEDRAW_DISPLAYFILTER_DEFORMER,
	BASEDRAW_DISPLAYFILTER_CAMERA,
	BASEDRAW_DISPLAYFILTER_LIGHT,
	BASEDRAW_DISPLAYFILTER_SCENE,
	BASEDRAW_DISPLAYFILTER_PARTICLE,
	BASEDRAW_DISPLAYFILTER_OTHER,
	BASEDRAW_DISPLAYFILTER_NULLBONES,
	BASEDRAW_DISPLAYFILTER_GRID,
	BASEDRAW_DISPLAYFILTER_HORIZON,
	BASEDRAW_DISPLAYFILTER_WORLDAXIS,
	BASEDRAW_DISPLAYFILTER_BOUNDS,
	BASEDRAW_DISPLAYFILTER_HUD,
	BASEDRAW_DISPLAYFILTER_SDS,
	BASEDRAW_DISPLAYFILTER_HIGHLIGHTING,
	BASEDRAW_DISPLAYFILTER_MULTIAXIS,
	BASEDRAW_DISPLAYFILTER_OBJECTHANDLES,
	BASEDRAW_DISPLAYFILTER_HANDLEBANDS,
	BASEDRAW_DISPLAYFILTER_SDSCAGE,
	BASEDRAW_DISPLAYFILTER_NGONLINES,
	BASEDRAW_DISPLAYFILTER_HIGHLIGHTING_HANDLES,

	BASEDRAW_DISPLAYFILTER_END,

	//////////////////////////////////////////////////////////////////////////

	BASEDRAW_SDISPLAY_GOURAUD					= 0,
	BASEDRAW_SDISPLAY_GOURAUD_WIRE		= 1,
	BASEDRAW_SDISPLAY_QUICK						= 2,
	BASEDRAW_SDISPLAY_QUICK_WIRE			= 3,
	BASEDRAW_SDISPLAY_FLAT_WIRE				= 4,
	BASEDRAW_SDISPLAY_HIDDENLINE			= 5,
	BASEDRAW_SDISPLAY_NOSHADING				= 6,
	BASEDRAW_SDISPLAY_FLAT						= 7,

	BASEDRAW_WDISPLAY_WIREFRAME				= 0,
	BASEDRAW_WDISPLAY_ISOPARMS				= 1,
	BASEDRAW_WDISPLAY_BOX							= 2,
	BASEDRAW_WDISPLAY_SKELETON				= 3,

	BASEDRAW_PROJECTION_PERSPECTIVE		= 0,
	BASEDRAW_PROJECTION_PARALLEL		= 1,
	BASEDRAW_PROJECTION_LEFT			= 2,
	BASEDRAW_PROJECTION_RIGHT			= 3,
	BASEDRAW_PROJECTION_FRONT			= 4,
	BASEDRAW_PROJECTION_BACK			= 5,
	BASEDRAW_PROJECTION_TOP				= 6,
	BASEDRAW_PROJECTION_BOTTOM			= 7,
	BASEDRAW_PROJECTION_MILITARY		= 8,
	BASEDRAW_PROJECTION_FROG			= 9,
	BASEDRAW_PROJECTION_BIRD			= 10,
	BASEDRAW_PROJECTION_GENTLEMAN		= 11,
	BASEDRAW_PROJECTION_ISOMETRIC		= 12,
	BASEDRAW_PROJECTION_DIMETRIC		= 13,

	//////////////////////////////////////////////////////////////////////////

	BASEDRAW_INSTANTRENDER_ACTIVE			= 4000,	// LONG
	BASEDRAW_INSTANTRENDER_RELATIVE,
	BASEDRAW_INSTANTRENDER_WORLDAXIS,
	BASEDRAW_INSTANTRENDER_X1,
	BASEDRAW_INSTANTRENDER_Y1,
	BASEDRAW_INSTANTRENDER_X2,
	BASEDRAW_INSTANTRENDER_Y2,
	BASEDRAW_INSTANTRENDER_TODO, // private

	BASEDRAW_DATA_EDITOR_AXIS_POS			= 5000,
		BASEDRAW_AXIS_POS_OFF							= 0,
		BASEDRAW_AXIS_POS_BL							= 1,
		BASEDRAW_AXIS_POS_TL							= 2,
		BASEDRAW_AXIS_POS_TR							= 3,
		BASEDRAW_AXIS_POS_BR							= 4,
	BASEDRAW_DATA_EDITOR_AXIS_TYPE		= 5001,
		BASEDRAW_AXIS_TYPE_WORLD					= 0,
		BASEDRAW_AXIS_TYPE_OBJECT					= 1,

	BASEDRAW_
};

#endif